/*
var PgCodeMaker = function(code) {

}
*/

var PgSmartStylesheet = function() {

    var base_code = null;
    var parts_code = null;

    var cs = null;


    var sass = require('node-sass');

    var parts = {};

    this.addPart = function(part_id, code) {
        parts[part_id] = code;
    }

    this.updatePart = function(part_id) {

    }

    var getCommentKey = function(part_id, end) {
        return `/* Part: ${part_id} ${end ? 'End' : 'Begin'} */`;
    }

    var rebuildPartsCode = function() {
        parts_code = '';

        $.each(parts, function(id, code) {
            parts_code += getCommentKey(id) + '\n' + code + '\n' + getCommentKey(id, true) + '\n\n';
        })
    }

    var getPartsFromSource = function(code) {
        var a = code.match(/\/\* Part\: (\w+) Begin \*\/\s+([\s\S]*?)\s+\/\* Part\: (\w+) End \*\//gm);
        parts = {};
    }

    this.update = function() {
        var p = new CrsaProfile();

        rebuildPartsCode();

        if(cs) {

            cs.setNeedFormatting(true);
            cs.setSource(parts_code, function () {
                cs.loaded = true;
                pinegrow.dispatchEvent('on_css_source_changed', null, {list: [cs], eventType: 'smart'});
                $('body').trigger('crsa-stylesheets-properties-changed');
                //pinegrow.selectedElements.repositionMenus();
            });
        }
        /*
        sass.render(options, function(error, result) {
            p.show('SASS Compile')
            if(error) {

            } else {
                result.css;
            }
        });
        */
    }

    this.init = function() {
        var project = pinegrow.getCurrentProject();
        var url = project.getAbsoluteUrl('assets/scss/components.scss');
        cs = pinegrow.stylesheets.getByUrl(url);

        if(cs) {

        } else {

        }
        console.log('SmartCSS', cs);

        project.smartStylesheet = this;
    }
}




var PgSmartScript = function() {

    var base_code = null;
    var parts_code = null;

    var parts = {};

    this.addPart = function(part_id, code, pgel) {
        parts[part_id] = code;

        var page = pgel.getPage();

        if(page) {
            pinegrow.executeScriptInPage(page, code);
        }
    }

    this.updatePart = function(part_id) {

    }

    var getCommentKey = function(part_id, end) {
        return `/* Part: ${part_id} ${end ? 'End' : 'Begin'} */`;
    }

    var rebuildPartsCode = function() {
        parts_code = '';

        $.each(parts, function(id, code) {
            parts_code += getCommentKey(id) + '\n' + code + '\n' + getCommentKey(id, true) + '\n\n';
        })
    }

    var getPartsFromSource = function(code) {
        var a = code.match(/\/\* Part\: (\w+) Begin \*\/\s+([\s\S]*?)\s+\/\* Part\: (\w+) End \*\//gm);
        parts = {};
    }

    this.update = function() {
        var p = new CrsaProfile();

        rebuildPartsCode();

        //save


    }

    this.init = function() {
        var project = pinegrow.getCurrentProject();
        var url = project.getAbsoluteUrl('assets/js/components.js');

        project.smartScript = this;
    }
}






$(function () {
    $('body').one('pinegrow-ready', function (e, pinegrow) {

        if(true || !pgIsDev() || !pgf.smart_blocks) return;

        pinegrow.showQuickError('Experimental Blocks are active! Should not be in release version.')

        var ps = new PgSmartStylesheet();

        var test = function() {

            ps.addPart('bubi', `
h1 {
color: pink;
}
`);

            ps.addPart('miskolin', `
p {
font-size:20px;
}
`)

            ps.update();
        }

        pinegrow.addEventHandler('on_page_stylesheets_loaded', function(page) {


            //setTimeout(function() {
                ps.init();
                test();
            //}, 5000)
        })
    })
});