class PgDmEngine {
    constructor(on_engine_ready) {
        this.is_ready = false;
    }

    isReady() {
        return this.is_ready;
    }

    activateOnPage(page, done) {

    }

    update(done) {

    }

    addFontsToPageViews(cs, urls) {

        var pages = typeof cs === 'function' ? cs() : pinegrow.stylesheets.getPagesForStylesheet(cs);
        pages.forEach(function(page) {
            page.getPageViews().forEach(function(pv) {
                var cid = getUniqueIdFast('fonts');
                var $html = pv.get$Html();
                $html.find('.pg-dm-temp').removeClass('pg-dm-temp').addClass('pg-dm-temp-old' + cid);
                var html = '';
                urls.forEach(function(url) {
                    html += `<link href="${url}" rel="stylesheet" class="pg-dm-temp"/>`;
                })
                if(html) {
                    $html.find('head').append(html);
                }

                setTimeout(function() {
                    try {
                        $html.find('.pg-dm-temp-old' + cid).remove();
                    } catch(err) {}
                }, 2000)
            })
        })
        setTimeout(function() {
            pinegrow.selectedElements.repositionMenusDelayed();
        }, 1000)
    }

    saveCSS() {

    }

    destroy() {

    }

}

