(function( $ ){
    var main_el = null;
    var mask = null;
    
    var settings = {};      
    var layout = 'B';  
    var edit = false;      
    var nav_shown_prev = false;
    var nav_shown_next = false;
    var nav_next = null;
    var nav_prev = null;
    var nav_timer = null;
    var nav_hover = false;
    var pllop_bar_opened = true;
    var is_touch = null;
    var is_iphone = null;
    var scr = false;
    var over_bar = false;
    var items = null;
    var my_url = null;
    var wait_c = 0;
    var user_reg_timer = null;
    var user_id = 0;
    var user_email = null;
    var after_resize_timer = null;
    
    var current_page = null;
    var current_index = 0;
    var nav_method = null;
    
    var loading_soundcloud = false;
    
    var fade_ui = true;
    
    var ghost_clicks = [];
    
    //var pix_img = '/img/s.gif';
    var pix_img = '/img/magic_dust.png';
    var diq = []; //deffered image queue
    var id_count = 0;
    var auto_size_mask = true;
    
    var settings = {
      'reg_user_url' : '/cob/callSmarty/MsbElement/externalRegisterUser/',
      'login_user_url' : '/cob/callSmarty/MsbElement/externalLoginUser/',
      'get_user_info' : '/cob/callSmarty/MsbElement/externalGetUserInfo/',
      'login_fb_get_user_info' : '/cob/callSmarty/MsbElement/externalLoginFBUserAndGetUserInfo/',
      'url_base' : '',
      'create_derived' : false,
      'nice_url' : null,
      'fb_app_id' : null,
      is_range : false,
      next_range : -1,
      prev_range : -1,
      range_mode: 'sub',
      range_inline : false,
      goto : 0
    };      
        
    var methods = {
       init : function( options ) {
           this.each(function(i,e){
               e = $(e);
               main_el = e;
           });
           if ( options ) { 
               $.extend( settings, options );
           }
           fade_ui = $.support.opacity;
           
           my_url = options.url;
           mask = $('#msb_mask');
           
           if('user_id' in options) user_id = options.user_id;
           if('user_email' in options) user_email = options.user_email;
           
           if(main_el.hasClass('horizontal')) layout = 'H';
           if(main_el.hasClass('vertical')) layout = 'V';
           if(main_el.hasClass('basic')) layout = 'B';

           edit = $('body').hasClass('edit_mode');
           
           items = $('#msb > div');
           
           if($('#msb_body').hasClass('custom-layout')) {
               auto_size_mask = false;
           }
           if(!edit) {
               
               //$(document).click(methods.ghostClicksCheck);
               if(document.addEventListener) document.addEventListener('click', methods.ghostClicksCheck, true);
               
               scr = items.length > 1 || methods.isTouchDevice() || settings.prev_range >= 0 || settings.next_range >= 0;
               
               if(layout == 'H') {
                   mask.addClass('msb_mask_class');
               }
               
               
               if(layout == 'H' && scr) {
                   if(!methods.isTouchDevice()) {
                       mask.after('<a class="next" id="crsa-nav-next"></a>');
                       mask.before('<a class="prev" id="crsa-nav-prev"></a>');
                       nav_next = $('#crsa-nav-next');
                       nav_prev = $('#crsa-nav-prev');
                       
                       if(auto_size_mask) {
                           nav_next.hide();
                           nav_prev.hide();
                       }
                       if(items.length == 1) {
                           nav_next.addClass('disabled');
                           nav_prev.addClass('disabled');
                       }
                       
                       if(settings.prev_range >= 0) nav_prev.show();
                       if(settings.next_range >= 0) nav_next.show();
                       
                       nav_next.click(methods.shouldGotoNextRange);
                       nav_prev.click(methods.shouldGotoPrevRange);
                       
                       $('#crsa-nav-next, #crsa-nav-prev').mouseenter(function() {
                           nav_hover = true;
                       }).mouseleave(function() {
                           nav_hover = false;
                       });
                       
                       main_el.mousemove(function() {
                           if(!auto_size_mask) return true;
                           if(!nav_shown_next) {
                                if(!nav_next.hasClass('disabled') || settings.next_range >= 0) {
                                    if(fade_ui) {
                                        nav_next.stop().fadeTo(400,1);        
                                    } else {
                                        nav_next.show();
                                    }
                                    nav_shown_next = true;
                                }
                           }
                           if(!nav_shown_prev) {
                                if(!nav_prev.hasClass('disabled') || settings.prev_range >= 0) {
                                    if(fade_ui) {
                                        nav_prev.stop().fadeTo(400,1);
                                    } else {
                                        nav_prev.show();
                                    }
                                    nav_shown_prev = true;
                                }
                           }
                           if(nav_timer != null) clearTimeout(nav_timer);
                           nav_timer = setTimeout(methods.hideNav, 1200);
                       });
                   } else {
                       console.log('touch device detected');
                   }
                   
                    
               }
               
               if(layout == 'H' && methods.isTouchDevice()) {
                  var $b = $('body');
                  
             /*     $b.bind('touchstart', methods.ignoreEvent);
                  $b.bind('touchmove', methods.ignoreEvent);
                  $b.bind('touchend touchcancel', methods.ignoreEvent);
                  */
                  
                  if(methods.isIphone()) {
                      $b.css('height','150%');
                      $(window).bind('load', function() {
                         setTimeout(methods.hideAddressBar, 500);
                      });
                  }
                  if('onorientationchange' in window) {
                    window.addEventListener('orientationchange', methods.hideAddressBar, false);
                  }
               }
               $("#pllop-bar-content").mouseenter(function() {
                   over_bar = true;
                   methods.openPllopBar();
               }).mouseleave(function() {
                   over_bar = false;
                   if(!$("#pllop-bar-content .pllop-bar-login-form").is(':visible')) {
                    methods.closePllopBar();
                   }
               });
               
               
               main_el.mousemove(function(event) {
                   if(event.pageY < 25) methods.openPllopBar();
               });
               
               //setTimeout(methods.closePllopBar, 1500);
               
               setTimeout(function() {
                   if(!over_bar) {
                    methods.closePllopBar(1000);
                   }
               }, 2500);
               if($("#pllop-bar-content").length > 0) {
                mask.after('<a id="crsa-show-bar" style="display:none;"></a>');
               }
               /*
               if(methods.isTouchDevice()) {
     //             $("#pllop-bar-content").bind('touchstart', function() {
                  $("#crsa-show-bar").bind('touchstart', function() {
                      methods.openPllopBar();
                      return false;
                  });
                  $("#pllop-bar-content").bind('touchstart', function(e) {
                      if(e.target.id == 'pllop-bar-content') {
                          methods.closePllopBar();
                          return false;
                      }
                  });
                  //$b.bind('touchmove', methods.ignoreEvent);
                  //$b.bind('touchend touchcancel', methods.ignoreEvent);
               }*/

               
               /*
               $("#pllop-tab").click(function() {
                   if(pllop_bar_opened) {
                       methods.closePllopBar();
                   } else {
                       methods.openPllopBar();
                   }
                   return false;
               });*/
               
               if(screen.height < 700) {
                   $("#pllop-tab").hide();
               }
               
               methods.wireMainMenu();
               methods.wireHotSpots();
           
              // methods.manageImages();
           }
           
           if(!edit) {
                methods.initNavigation();
           }               
          // console.log('calling onresize');
           methods.onResize();

           main_el.bind('dvLayoutComplete', function() {
               if(settings.goto == '') {
                   settings.goto = 0;
               } else if(settings.goto == 'last') {
                   settings.goto = items.length - 1;
               } else {
                   settings.goto = parseInt(settings.goto);
               }
               if(items.length > 0) current_page = $(items.get(settings.goto));
               methods.gotoPage(current_page, 0);
               //methods.onItemActivated(settings.goto, current_page);
               
             //  console.log('went goto');
           });
           
           $(window).resize(function(e) {
                methods.onResize(e);
           });
       },
       shouldGotoNextRange : function(e) {
          if(current_index == items.length - 1  && settings.next_range >= 0) {
              methods.gotoNextRange();
          }
          return false;
       },
       gotoNextRange : function() {
        //   console.log('goto next');
           if(settings.next_range < 0) return;
           methods.waitStart();
           var url = settings.nice_url + '/' + settings.range_mode + ':' + settings.next_range;;
           if(settings.range_inline) url = url + '/inline:1';
           window.location.href = url;
           if(methods.isTouchDevice()) main_el.swipepage('freeze');
       },
       shouldGotoPrevRange : function(e) {
          if(current_index == 0 && settings.prev_range >= 0) {
              methods.gotoPrevRange();
          }
          return false;
       },
       gotoPrevRange : function() {
          // console.log('goto prev');
           if(settings.prev_range < 0) return;
           methods.waitStart();
           var url = settings.nice_url + '/' + settings.range_mode + ':' + settings.prev_range;
           if(settings.range_mode != 'item') url = url + '/goto:last';
           if(settings.range_inline) url = url + '/inline:1';
           window.location.href = url;
           if(methods.isTouchDevice()) main_el.swipepage('freeze');
       },
       ghostClicksRegisterEvent : function(x, y) {
           ghost_clicks.push(x, y);
      //     console.log('added ' + x + ', ' + y);
           window.setTimeout(methods.ghostClicksRemoveEvent, 500);       
       },
       ghostClicksRemoveEvent : function() {
           ghost_clicks.splice(0, 2);
       },
       ghostClicksCheck : function(event) {
     //      console.log('checking ' + event.pageX + ', ' + event.pageY);
          for (var i = 0; i < ghost_clicks.length; i += 2) {
            var x = ghost_clicks[i];
            var y = ghost_clicks[i + 1];
            if ((Math.abs(event.pageX - x) < 50 && Math.abs(event.pageY - y) < 50) || false) {
              event.stopPropagation();
              event.preventDefault();
       //       console.log('click canceled');
           //   event.pageX = 100000;
              return false;
            }
          }
       },
       wireHotSpots : function() {
           $('div.crsa-spot').each(function(i,e) {
               var $s = $(e);
               var $a = $s.find('a.crsa-spot-anchor');
               var $c = $s.find('div.crsa-spot-content');
               
               $s.click(function(event) {
                   var url = $a.attr('href');
                   var product_id = $a.attr('data-product-id');
                   if(product_id) {
                       var p = $('#msb').crsashop('getProduct', product_id);
                       var pos = $s.offset();
                       var opt = {
                           position: 'absolute',
                           left: pos.left + 'px',
                           top: pos.top + 'px',
                           autoclose: true
                       };
                           
                       $('#msb').crsashop('showInfoBox', p, $s.parent(), opt);
                   } else {
                       methods.openPllop(url, true);
                   }
                   return false;
               });
           });
       },
       openPllop : function(url, inline, resize) {
           if(typeof resize == 'undefined') resize = false;
           var $e = $(document.createElement('div'));
           $e.addClass('msb-sub');
           $('#cms').before($e);
           
           var pad = resize ? 40 : parseInt(methods.getWindowHeight() * 0.05);
           
           var setH = function() {
               $e.hide();
               var h = methods.getWindowHeight();
               var w = $(window).width();
               var wh = parseInt(h - pad*2);
               var top = parseInt(pad);
               var ww = w - pad*2;
               
               $e.show();
               $e.css('height',wh + 'px').css('top', top + 'px').css('width',ww + 'px').css('left',pad + 'px');
           }
           if(resize) {
               setH();
               $(window).bind('resize.openpllop', setH);
           }
           
           url = url + '/embeded:1';
           if(inline) url += '/inline:1';
           
           var s = '<iframe src="' + url + '" width="100%" height="100%" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe><a class="crsa-close"></a>';
           $e.html(s);
           
           $e.find('iframe').focus();
           
           var onClose = function() {
               $e.remove();
               if(resize) {
                $(window).unbind('resize.openpllop');
               }
           };
           
           $e.overlay({
                    mask: {
                        color: '#000000',
                        loadSpeed: 200,
                        opacity: 0.8,
                        maskId: 'crsa-mask'
                    },
                    closeOnClick: true,
                    closeOnEsc: false,
                    left: 'center',
                    top: pad,
                    onClose : onClose
             });

           var api = $e.data("overlay");
           api.load();
           
           $e.find('a.crsa-close').click(function() {
               api.close();
               onClose();
               return false;
           });
       },
       getWindowHeight : function() {
        return window.innerHeight ? window.innerHeight : $(window).height();
       },
       hideAddressBar : function() {
           window.scrollTo(0,1);
           setTimeout(methods.triggerResize, 500);
       },
       triggerResize : function() {
           $(window).trigger('resize');
           //var h = window.innerHeight ? window.innerHeight : $(window).height()
         //  alert(h);
           //alert(jQuery(window).height());
       },
       getCreateDerived : function() {
           return settings.create_derived;
       },
       ignoreEvent : function(e) {
           e.preventDefault();
           e.stopPropagation();
       },
       hideNav : function() {
           if(nav_hover) {
               nav_timer = setTimeout(methods.hideNav, 1200);
               return;
           }
           if(nav_shown_next) {
                if(fade_ui) {
                    nav_next.stop().fadeTo(750, 0);        
                } else {
                    nav_next.hide();
                }
                nav_shown_next = false;
           }
           if(nav_shown_prev) {
                if(fade_ui) {
                    nav_prev.stop().fadeTo(750, 0)
                } else {
                    nav_prev.hide();
                }
                nav_shown_prev = false;
           }
       },
       initNavigation : function() {
            //var scr = true;
            if(layout == 'H') {
                if(scr) {
                    if(methods.isTouchDevice()) {
                        main_el.swipepage({allowPageScroll: 'none', onSeek : methods.onItemActivated, onPrevRange: methods.gotoPrevRange, onNextRange: methods.gotoNextRange});
                        main_el.css('left','0px');
                        nav_method = 'swipe';
                    } else {                    
                        var api = mask.data("scrollable");
                        var i = -1;
                        if(api != null) i = api.getIndex();
                        
                        mask.scrollable({
                            'onSeek' : function() {
                                if(auto_size_mask) {

                                    if(nav_shown_next && nav_next.hasClass('disabled') && settings.next_range < 0) {
                                        if(fade_ui) {
                                            nav_next.stop().fadeTo(200, 0);        
                                        } else {
                                            nav_next.hide();
                                        }
                                        nav_shown_next = false;
                                    } else if(!nav_shown_next && !(nav_next.hasClass('disabled') || settings.next_range >= 0)) {
                                        if(fade_ui) {
                                            nav_next.stop().fadeTo(200, 1);        
                                        } else {
                                            nav_next.show();
                                        }
                                        nav_shown_next = true;
                                    }
                                    if(nav_shown_prev && nav_prev.hasClass('disabled') && settings.prev_range < 0) {
                                        if(fade_ui) {
                                            nav_prev.stop().fadeTo(200, 0);
                                        } else {
                                            nav_prev.hide();
                                        }
                                        nav_shown_prev = false;
                                    } else if(!nav_shown_prev && !(nav_prev.hasClass('disabled') || settings.prev_range >= 0) ) {
                                        if(fade_ui) {
                                            nav_prev.stop().fadeTo(200, 1)
                                        } else {
                                            nav_prev.show();
                                        }
                                        nav_shown_prev = true;
                                    }
                                    if(nav_timer != null) clearTimeout(nav_timer);
                                    nav_timer = setTimeout(methods.hideNav, 1200);
                                }
                                
                                var ind = api.getIndex();
                                var $item = items.eq(ind);
                                methods.onItemActivated(ind, $item);
                            }
                        });
                        nav_method = 'scrollable';
                        
                        var api = mask.data("scrollable");
                        if(i >= 0) {
                            api.seekTo(i,0);
                        }
                    }
                }
            }
       },
       onResize : function(event) {
          // console.log('onResize ' + event);
           if(typeof event == 'object') {
            //    console.log(event.type + ' ' + event.which + ' ' + event.metaKey);
            }
            if(!edit) {
                var h = methods.getWindowHeight();
                var w = jQuery(window).width();
            } else {
                var h = $('#msb').height();
                var w = $('#msb > div').width();
            }
            var $body = $('body');
            if(h > w) {
                $body.addClass('portrait').removeClass('landscape');
            } else {
                $body.removeClass('portrait').addClass('landscape');
            }
            if(w < 950) {
                $body.addClass('width_narrow').removeClass('width_medium');
            } else if(w < 1200) {
                $body.removeClass('width_narrow').addClass('width_medium');
            } else {
                $body.removeClass('width_narrow').removeClass('width_medium');
            }
            items = $('#msb > div').filter(":visible");
            
            main_el.trigger('crsaResizeLayout');
            
            if(!edit) { 
                
                if($body.hasClass('show_bar') && auto_size_mask) {
                    mask.css('top','25px').css('height',(h-25) + 'px');
                }
                if(layout == 'H') {
                    if(scr) {
                        if(methods.isTouchDevice()) {
                        } else {                    
                            var api = mask.data("scrollable");
                            var i = -1;
                            if(api != null) i = api.getIndex();
                            var api = mask.data("scrollable");
                            if(i >= 0) {
                                api.seekTo(i,0);
                            }
                        }
                    }
                }
            }
            if(after_resize_timer != null) clearTimeout(after_resize_timer);
            after_resize_timer = setTimeout(methods.triggerAfterResize, 500);
            /*
            var ignorewheel = false;
            $(document).bind('mousewheel', function(e) {
                console.log('doc ' + e.target.id);
                if(current_page != null && !ignorewheel) {
                    ignorewheel = true;
                    current_page.find('div.crsa-inner').trigger(e);
                    ignorewheel = false;
                }
            });
            */
           // methods.repositionPllopBar();
       },
       triggerAfterResize : function() {
           after_resize_timer = null;
           main_el.trigger('crsaAfterResize');
       },
       onItemActivated : function(i, $e) {
      //     if(i < 0) i = $e.index();
           current_page = $e;
           var forward = i >= current_index;
           current_index = i;
           main_el.trigger('crsaPageShown', [$e, forward]);
        //   console.log('item activated ' + $e[0].id);
        //   var id = $e[0].id;
         //  console.log(id);
        //   var url = i > 0 ? "/?page=" + id : "";
        //   window.History.replaceState({state:i}, id, my_url + url);
            methods.selectActivePageInMenu();
       /*     
            $e.find('div.crsa-content-wrap').focus();
            $e.find('div.crsa-content-wrap').bind('mousewheel wheel', function(e) {
                console.log(e.target.id);
            });
        */    
       },
       selectActivePageInMenu : function() {
           if(current_page) {
               var id = '#' + current_page.attr('id');
               if(id) {
                   $('div.crsa-menu li').removeClass('selected');
                   $('div.crsa-menu li a[href=' + id + ']').each(function(i,e) {
                       var $li = $(e).parent();
                       $li.addClass('selected');
                   });
               }
           }
       },
       generateMenu : function($el) {
           var els = main_el.find('> div').filter(":visible");
           var b = '';
           var ib = '';
           els.each(function(i,e) {
               var $e = $(e);
               var $a = $e.find('a.msb_element_anchor');
               if($a.length > 0) {
                   var t = $a.attr('title');
                   if(t) {
                       ib += '<li><a href="#' + $e.attr('id') + '">' + t + '</a></li>';
                   }
               }
           });
           if(ib) b = '<ul>' + ib + '</ul>';
           $el.html(b);
           methods.wireMainMenu();
       },
       wireMainMenu : function() {
           $('div.crsa-menu li a').unbind('click.crsa touchstart.crsa').bind('click.crsa touchstart.crsa', function(e) {
               var $a = $(e.currentTarget);
               var $li = $a.parent();
        //       if($li.hasClass('selected')) return false;
               var id = $a.attr('href');
               methods.gotoPage($(id));
               $li.parent().find('> li').removeClass('selected');
               $li.addClass('selected');
               return false;
           });
       },
       gotoPage : function(i_or_e, dur) {
           var i = i_or_e;
           if(typeof i_or_e == 'object') {
               i = items.index(i_or_e);
           }
           if(i < 0) {
               console.log('gotoPage : page not found');
               return;
           } 
           switch(nav_method) {
               case 'swipe':
                main_el.swipepage('seekTo', i, dur);
                break;
               case 'scrollable':
                var api = mask.data("scrollable");
                api.seekTo(i, dur);
                break;
           }
       },
       gotoNext : function() {
           if(items.length < 2 || current_page == null) return;
           if(items.length == current_index + 1) return;
           methods.gotoPage(current_index + 1);
       },
       gotoPrev : function() {
           if(items.length < 2 || current_page == null) return;
           if(current_index == 0) return;
           methods.gotoPage(current_index - 1);
       },
       gotoFirst : function() {
           if(items.length < 1 || current_page == null) return;
           methods.gotoPage(0);
       },
       gotoLast : function() {
           if(items.length < 1 || current_page == null) return;
           methods.gotoPage(items.length - 1);
       },
       getNext : function(all) {
           if(typeof all == 'undefined') all = false;
           var list = all ? $('#msb > div') : items;
           if(list.length < 2 || current_page == null) return null;
           var ci = list.index(current_page);
           if(ci < 0) return;
           if(list.length == ci + 1) return null;
           return $(list.get(ci + 1));
       },
       unlockPage : function($e) {
           $e.removeClass('crsa-locked');
           methods.onResize();
           methods.generateMenu($('div.crsa-menu'));
       },
       lockPage : function($e) {
           $e.addClass('crsa-locked');
           methods.onResize();
           methods.generateMenu($('div.crsa-menu'));
       },
       lockPages : function(a) {
           $.each(a, function(i,e) {
               var $e = $(e);
               $e.addClass('crsa-locked');
           });
           //methods.onResize();
           methods.generateMenu($('div.crsa-menu'));
       },
       unlockAllPages : function() {
           var p = main_el.find('.crsa-locked');
           if(p.length > 0) {
               p.removeClass('crsa-locked');
              // methods.onResize();
               methods.generateMenu($('div.crsa-menu'));
             //  methods.gotoPage(p);
           }
       },
       unlockNextPage : function() {
           var $n = methods.getNext(true);
           if($n) methods.unlockPage($n);
       },
       makeVisible : function($ie) {
            var ip = $ie.position();
            //var ip = $ie.offset();//ie9 workaround
            if(ip == null) return;
            var iw = $ie.innerWidth();
            var w = $ie.parent().innerWidth();
            //console.log('left ' + ip.left);
            if(ip.left < 0 || ip.left + iw > w) {
                var pad = iw - $ie.width();
                var nw = Math.floor(((w * 0.8) - pad) / w * 100);
                if($ie.data('crsaOrigSP') == null) {
                    var od = {left: $ie.css('left'), right: $ie.css('right'), width: $ie.css('width'), cutAt: w};
                    $ie.data('crsaOrigSP', od);
                }
                $ie.css('left','10%').css('right','auto').css('width',nw + '%');
            } else {
                var od = $ie.data('crsaOrigSP');
                if(od != null && od.cutAt > w * 1.1) {
                    $ie.css('left',od.left).css('right',od.right).css('width',od.width);
                    $ie.data('crsaOrigSP', null);
                }
            }
            var sh = $ie.attr('scrollHeight');
          //  console.log('sh ' + sh);
            var ih = $ie.innerHeight();
            
            if(sh > ih) {
              //  $ie.css('bottom','auto');
                var ih = $ie.innerHeight();
            }
            var h = $ie.parent().innerHeight();
            if(ip.top < 0) {
             //   $ie.css('top','0').css('bottom','auto');
                ip = $ie.position();
                //ip = $ie.offset();//ie9 workaround
            }
            
            var space = h - ip.top;
            if(space < ih || true) {
                if(methods.isTouchDevice()) $ie.touchvertscroll({});
            } else {
                $ie.css('height', 'auto');
            }
            if(methods.isTouchDevice()) {
                $ie.bind('melt', methods.onMelt);
            }
       },
       onMelt : function(e) {
           $(e.currentTarget).stop().fadeTo(600, 0).data('crsaMelted', true).parent().bind('touchstart touchmove', function(e) {
                var $ie = $(e.currentTarget).find('.crsa-inner');
                var m = $ie.data('crsaMelted');
                if(m) {
                    $ie.stop().fadeTo(250, 1);
                    $ie.data('crsaMelted', false);
                }
           });
       },
       fsStretchContainer : function($e, opt) {
           //alert('str');
            if(edit) return;
            var h = methods.getWindowHeight();
            var w = jQuery(window).width();
            
            h = mask.height();
            w = mask.width();
            
            if(!opt.only_width && opt.min_height) if(h < opt.min_height) h = opt.min_height;
            if(opt.min_width && w < opt.min_width) w = opt.min_width;
            var si = $e.data('crsart_fs');
            if(si == null) {
                si = {};
                si.o_width = $e.css('width');
                si.o_height = $e.css('height');
                si.o_min_height = $e.css('min-height');
                si.o_overflow = $e.css('overflow');
                $e.data('crsart_fs', si);
            }
            
            if(document.location == 'http://dev.pllop.com/11025') {
              //  alert('resize cont ' + w + ' x ' + h);
            }
            
            
            if(!opt.only_width) {
                $e.css('width',w + 'px').css('height',h + 'px').css('min-height',h + 'px');
//                $e.css('width',w + 'px').css('height',h + 'px').css('overflow','hidden');
            } else {
                $e.css('width',w + 'px');
            }
            //set inner height
            $e.find('> div.crsa-content-wrap > div.crsa-inner').each(function(i,ie) {
                var $ie = $(ie);
                var ip = $ie.position();
                var ih = $ie.innerHeight();
                var space = $e.height() - ip.top;
                var tt = $ie.css('top');
                var tb = $ie.css('bottom');
              /*  if(tt != null && tt != 'auto' && tb != null && tb != 'auto') {
                } else {*/
                    if(space < ih) {
                      //  if(methods.isTouchDevice()) $ie.touchvertscroll({});
                       // $ie.css('height', space + 'px');
                        //$ie.jScrollPane();
//                        $ie.css('height', 'auto');
                    } else {
                     //   $ie.css('height', 'auto');
                    }
                //}
               // $ie.touchvertscroll({});
            });
        },       
       fsUnstretchContainer : function($e, opt) {
            if(edit) return;
            var si = $e.data('crsart_fs');
            if(si != null) {
                $e.css('width',si.o_width).css('height',si.o_height).css('min-height',si.o_min_height).css('overflow',si.o_overflow);
            }    
       },
       fsStretchImages : function($e, popt) {
            var opt = {
                hpos: 'center',
                vpos: 'center',
                min_width: 0,
                min_heigh : 0,
                show_whole : 0,
                auto_show_whole : 0,
                max_width : 0,
                max_height : 0
            };
            if ( popt ) { 
                $.extend( opt, popt );
            }
            if($e == null || $e.length == 0) return;
            //var h = jQuery('#{$id}').height();
            var h = $e[0].clientHeight;
            var w = $e.width();
            
           
            var imgsize = null;
            var maxh = 0;                
            $e.find('> div.msb_bcks > .msb_element_bck').each(function(i,e) {
                $i = $(e);
                var si = $i.data('crsart_fs');
                if(si == null) {
                    var d = getImageSize(e);
                    si = {};
                    si.o_width = d.w;
                    si.o_height = d.h;
                    si.o_left = $i.css('left');
                    si.o_top = $i.css('top');
                    $i.data('crsart_fs', si);
                }
                if(opt.auto_show_whole) {
                    opt.show_whole = (w > h && d.h > d.w) || (h > w && d.w > d.h);
                }
                if(opt.show_whole && opt.show_whole != '0') {
                    opt.max_width = w;
                    opt.max_height = h;
                }
                if(!opt.only_width) {
                    dvResizeImage(e, w, h, opt.hpos, opt.vpos, opt.min_width, opt.min_height, opt.max_width, opt.max_height); 
                } else {
                    imgsize = dvResizeImage(e, w, -1, opt.hpos, opt.vpos, opt.min_width, opt.min_height, opt.max_width, opt.max_height); 
                    if(imgsize.height > maxh) maxh = imgsize.height;
                }
            } );
            if(opt.only_width) {
                if(maxh > 0) {
                    $e.css('min-height',maxh + 'px').css('height','auto').css('overflow','hidden');
                }
            }
       },
       fsUnstretchImages : function($e) {
            $e.find('> div.msb_bcks > .msb_element_bck').each(function(i,e) {
                $i = $(e);
                var si = $i.data('crsart_fs');
                if(si != null) {
                    $i.attr('width', si.o_width).attr('height', si.o_height).css('left', si.o_left).css('top', si.o_top);
                }
            });
       },
       centerH : function($e, sel) {
           var pw = $e.parent().innerWidth();
           var w = $e.innerWidth();
           var x = (pw - w)/2;
           if(typeof sel != 'undefined') {
               $.rule(sel).css('left',x + 'px').css('right','auto');
           } else {
               $e.css('left',x + 'px').css('right','auto');
           }
       },
       centerV : function($e, sel) {
           var pw = $e.parent().innerHeight();
           var w = $e.innerHeight();
           var y = (pw - w)/2;
           if(typeof sel != 'undefined') {
               $.rule(sel).css('top',y + 'px').css('bottom','auto');
           } else {
               $e.css('top',y + 'px').css('bottom','auto');
           }
       },
       openPllopBar : function() {
          // if(typeof d == 'undefined') d = 500;
           if(!pllop_bar_opened) {
               $("#pllop-bar-content").css('display','block');
               $("#pllop-bar-content").stop().fadeTo(300, 1, function() {
               });
               if(fade_ui) {
                $('#crsa-show-bar').fadeTo(300,0);
               } else {
                   $('#crsa-show-bar').hide();
               }
           }
           pllop_bar_opened = true;
           /*
           var wh = jQuery(window).height();
           var h = (wh - 500) / 2;
           if(h < 50) h = 50;
           $("#pllop-bar-content").show();
           $("#pllop-bar").stop().css('top',wh + 'px').animate({top: h + "px"}, d);       
           */
       },
       closePllopBar : function(d) {
           return;
           if(typeof d == 'undefined') d = 300;
           if(pllop_bar_opened) {
               $("#pllop-bar-content").stop().fadeTo(d, 0, function() {
                   $("#pllop-bar-content").css('display','none');
               });
               if(fade_ui) {
                $('#crsa-show-bar').fadeTo(d,1);
               } else {
                   $('#crsa-show-bar').show();
               }
           }           
           pllop_bar_opened = false;
        /*   var h = jQuery(window).height();
           if(d == 0) {
                $("#pllop-bar-content").hide();
                $("#pllop-bar").css('top','100%');
                return;
           }
            $("#pllop-bar").stop().animate({top: h + "px"}, {duration:d, complete:function() {
                $("#pllop-bar-content").hide();
                $("#pllop-bar").css('top','100%');
            }});*/
       },
       repositionPllopBar : function() {
           if(pllop_bar_opened) {
               methods.openPllopBar(0);
           } else {
               methods.closePllopBar(0);
           }
       },
       showEmbedCode : function() {
           var c = '<iframe src="' + settings.nice_url + '/embeded:1" width="800" height="480" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>';
           var id = 'pllop-embed-code';
           var cms = $('#cms');
           var b = '<div id="' + id + '"><form><label>Width: </label><input class="pec_width" value="800" />px&nbsp;&nbsp;&nbsp;&nbsp;<label>Height: </label><input class="pec_height" value="480" />px&nbsp;&nbsp;&nbsp;&nbsp;(Minimum size is 400px x 200px)<br /><br /><label>HTML code: </label><textarea></textarea></form>' + c + '<a class="crsa-close">Close</a></div>';
           cms.append(b);
           var $e = $('#' + id);
           var $w = $e.find('input.pec_width');
           var $h = $e.find('input.pec_height');
           var $if = $e.find('> iframe');
           var $t = $e.find('textarea').val(c);
           var w = '640';
           var h = '480';
           
           var ww = $(window).width();
           var wh = $(window).height();
           
           $w.bind('input', function() {
               var v = $w.val();
               if(v < 400) v = 400;
               w = v;
               $if.css('width', v + 'px');
               $t.val(c.replace('800', $w.val()).replace('480',h));
           });
           $h.bind('input', function() {
               var v = $h.val();
               if(v < 200) v = 200;
               h = v;
               $if.css('height', v + 'px');
               $t.val(c.replace('480', $h.val()).replace('800',w));
           });
           
           if($e.width() > ww * 0.8) $e.css('width', (ww * 0.8) + 'px');
           
           $e.overlay({
                    mask: {
                        color: '#000000',
                        loadSpeed: 200,
                        opacity: 0.8,
                        maskId: 'crsa-mask'
                    },
                    closeOnClick: false,
                    closeOnEsc: false,
                    left: 'center',
                    top: '10%'
             });
           var api = $e.data("overlay");
           api.load();
           
           $e.find('a.crsa-close').click(function() {
               api.close();
               $e.remove();
               return false;
           });
           
       },
       soundcloudEmbed : function($dest, url) {
           var doit = function($d, u) {
               SC.oEmbed(url, {},  $dest.get(0));
           };
           $.getJSON('http://soundcloud.com/oembed?callback=?', {format: 'js', url: url, iframe: true },
                function(data) {
                    $dest.html(data['html'])
                }
           )
     /*     if(typeof SC == 'object') {
               doit($dest, url);
           } else {
               if(!loading_soundcloud) {
                   loading_soundcloud = true;
                   $.getScript('http://connect.soundcloud.com/sdk.js', function() {
                       loading_soundcloud = false;
                       SC.initialize({client_id: "3a392c976fd7f44afd8c5005cc3134d6"});
                       doit($dest, url);
                   });
               } else {
                  // setTimeout(function() { methods.soundcloudEmbed($dest, url);}, 50);
               }
           }*/
       },
       isTouchDevice : function() {  
          //if(document.location == 'http://dev.pllop.com/11025') return false;
          // return false;
          //return true;
           return "ontouchstart" in window;
           
           if(is_touch != null) return is_touch;
          try {  
            document.createEvent("TouchEvent"); 
            is_touch = true; 
            return true;  
          } catch (e) {  
            is_touch = false;
            return false;  
          }  
        },
        isIphone : function() {
            if(is_iphone != null) return is_iphone;
            return navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPod/i);
        },
        getUserId : function() {
            return user_id;
        },
        getUserEmail : function() {
            return user_email;
        },
        getUrlBase : function() {
            return settings.url_base;
        },
        invalidateLogin : function() {
            user_id = 0;
            user_email = null;
        },
        doFacebookLogin : function(func) {
            FB.login(function(response) {
               if (response.authResponse) {
                 console.log('Welcome!  Fetching your information.... ');
                 methods.waitStart();
                $.ajax({
                      url: settings.url_base + settings.login_fb_get_user_info,
                      dataType: 'json',
                      type: 'post',
                      data: {},
                      beforeSend:function(request) { 
                          request.setRequestHeader('X-Update', 'dummy');
                      },           
                      success: function(ret){
                          if(ret.status == 'ok') {
                            console.log('ok');
                            settings.temp_user = false;
                            user_id = ret.user_id;
                            user_email = ret.user_email;
                            main_el.trigger('crsaUserLoggedIn');
                            
                            if(typeof func == 'function') func(response.authResponse);
                            
                          } else {
                              alert('Facebook login error');
                          }
                          methods.waitDone();
                      },
                        error: function(a,b,c) {
                            methods.waitDone();
                            alert(a.responseText);
                        }          

                });             
                 
                 
                 
               } else {
                 alert('User cancelled login or did not fully authorize.');
               }
             }, {scope: 'email'});
        },
        fbPublish : function(data, func) {
              var opt = {
                  method: 'feed'
              };
              $.extend( opt, data );
              FB.ui(opt, function(r) {
                    if(r && r.post_id) {
                        console.log('published ' + r.post_id);
                        if(func != null) func(r.post_id);
                    } else {
                        console.log('not published');
                    }
                });        
        },
        fbShare : function(data, func, reqLogin) {
            FB.getLoginStatus(function(response) {
                if (response.authResponse || !reqLogin) {
                    methods.fbPublish(data, func);
                } else {
                    FB.login(function(response) {
                       if (response.authResponse) {
                         console.log('Welcome!  Fetching your information.... ');
                         methods.fbPublish(data, func);
                       } else {
                         console.log('User cancelled login or did not fully authorize.');
                       }
                     }, {});
                }
            });
        },    
        fbOnLike : function(url) {
            methods.unlockAllPages();
        },
        fbIsUserFan : function() {
            FB.api('?id=' + settings.nice_url, function(r) {
                if(r.id) {
                    FB.api('/me/likes/' + r.id, function(rr) {
                        if(rr.data && rr.data.length > 0) {
                            console.log('User likes this page');
                        }
                    });
                }
            });
        },
        fbDoAction : function(action, level) {
            if(typeof level == 'undefined' || !level) level = 0;
            FB.api(
                '/me/pllopit:' + action + '?pllop=' + settings.nice_url,
                'post',
                function(response) {
                   if (!response || response.error) {
                       if(response.error.code == 200 && level == 0) {
                            FB.login(function(r) {
                               if (r.authResponse) {
                                   methods.fbDoAction(action, level + 1);
                               } else {
                               }
                             }, {scope:'publish_actions'});                           
                       } else {
                           alert('Error occured ' + response.error.message);
                       }
                   } else {
                      alert('Like was successful! Action ID: ' + response.id);
                   }
                });
        },
        fbShowAlbum : function(dest, id) {
            var b = '<div class="crsa-album">';
            FB.api('/' + id + '/photos', function(response) {
              if(response.data) {
                  $.each(response.data, function(ind, i) {
                      b += '<div class="crsa-photo"><a href="' + i.source + '" target="_blank"><img src="' + i.picture + '" /></a></div>';
                  });
                  b += '</div>';
                  dest.append(b);
                  
                  var $alb = dest.find('div.crsa-album');
                  $alb.find('a').each(function(n, a) {
                      $(a).click(function(e) {
                          var index = n;
                          methods.showPhotoStrip($alb, index, response.data);
                          return false;
                      });
                  });
              }
            });            
        }, 
        wireStrip : function($s, jump) {
            var drag = false;
            var p = $s.position();
            var ox = 0;
            
            var active = null;
            var active_index = -1;
            var skip_moves = 0;
            var moved = false;
            
            var items = $s.find('> div');
            
            var use3d = ('WebKitCSSMatrix' in window) && true;
            
            var getTouches = function(e) {
                if (e.originalEvent) {
                    if (e.originalEvent.touches && e.originalEvent.touches.length) {
                        return e.originalEvent.touches;
                    } else if (e.originalEvent.changedTouches && e.originalEvent.changedTouches.length) {
                        return e.originalEvent.changedTouches;
                    }
                }
                return e.touches;
            };
            var scrollImages = function(distance, duration)
            {
                var $e = $s;
                var value = distance;//(distance<0 ? "" : "-") + Math.abs(distance).toString();
                if(use3d) {
                    $e.css('-webkit-transition-delay','0');
                    $e.css("-webkit-transition-duration", (duration/1000).toFixed(1) + "s");
                    $e.css("-webkit-transform", "translate3d("+value +"px,0px,0px)");
                    
                    if(duration > 0) {
                        $e.bind('webkitTransitionEnd.sp', function(event){
                            $e.unbind(event);
                            // console.log(event.originalEvent.propertyName);
                            if(event.originalEvent.propertyName == '-webkit-transform' ) {
                            }
                            getActive();
                            return false;
                        });
                    }
                    
                } else {
                    if(duration == 0) {
                        $s.css('left', (value) + 'px');
                    } else {
                        $s.stop().animate({ 'left': (value) + 'px'}, {duration:duration, complete: getActive, easing: 'swing'}); 
                    }
                }
            };       
            
            var getTransform = function($el) {
            //    console.log($el.css('-webkit-transform'));
                var t = $el.css('-webkit-transform');
                if(!t) return '0';
                
                var results = t.replace(/px/g, '').match(/[a-z3]*\(([^,]*)/)

                if(!results) return '0';
                return results[1];

            };
            
            var getLeftOffset = function($el) {
                var t = parseInt(getTransform($el));
                var l = parseInt(($el.css('left').replace('px','')));
             //   console.log('pos left: ' + t + ' - ' + l);
                return t + l;
            };
            
            var gotoItem = function(i, duration) {
                if(typeof duration == 'undefined') duration = 450;
                if(typeof i == 'object') {
                    var $i = $(i);
                } else {
                    var $i = $(items.get(i));
                }
                var psx = $i.position().left;
                var w = $s.parent().width();
                psx = psx - (w - $i.width())/2;
                scrollImages(-psx, duration);
                //$s.animate({ 'left': (-psx) + 'px'}, {duration:duration, complete: getActive, easing: 'swing'});  
                //getActive();
            };
            
            var gotoNext = function() {
                if(items.length > active_index+1) {
                    gotoItem(active_index+1);
                } else {
                    closeStrip();
                }
            };

            var gotoPrev = function() {
                if(active_index > 0) {
                    gotoItem(active_index-1);
                } else {
                    closeStrip();
                }
            };
            
            var gotoActive = function() {
                if(active_index >= 0) gotoItem(active_index);
            }
            
         /*   main_el.bind('crsaAfterResize.strip', function() {
                gotoActive();
            });*/
            
            var getActive = function() {
                var w = $s.parent().width();
                var o = $s.offset();
                var sx = -getLeftOffset($s);
                var ex = sx + w;
                var hx = (sx + ex) / 2;
                
                var psx = 0;
                var pex = 0;
                
                items.each(function(i,e) {
                    var $e = $(e);
                    var pw = $e.width();
                    
                  //  console.log(i + ' ' + psx + ' [ ' + sx + ' - ' + ex + ']');
                    if(psx < hx && psx + pw > hx) {
                        if(active_index != i && active_index >= 0) {
                            active.removeClass('active');
                        }
                        if(active_index != i) {
                            active = $e;
                            active_index = i;
                            $e.addClass('active');
                        }
                        return false;
                    }
                    psx = psx + 10 + pw;    
                });
            };

            var closeStrip = function() {
                var api = $s.data("overlay");
                api.close();
            };
            
            var onCloseStrip = function() {
               main_el.unbind('crsaAfterResize.strip');
               $('body').unbind('mouseup.strip');
               $s.unbind('mouseup.strip');
               $('body').unbind('mousemove.strip');
               $('body').unbind('keyup.strip');
               $('body').unbind('keydown.strip');
               $s.unbind('gotoActive.strip');
               main_el.unbind('crsaAfterResize.strip');
               $('#crsa-mask').unbind('click.strip');
               $s.remove();
            };
            
            var wh = methods.getWindowHeight();
            
            $s.overlay({
                    mask: {
                        color: '#000000',
                        loadSpeed: 200,
                        opacity: 0.8,
                        maskId: 'crsa-mask'
                    },
                    closeOnClick: false,
                    closeOnEsc: true,
                    fixed: false,
                    left: 10,
                    top: parseInt((wh - $s.innerHeight())/2),
                    onClose: onCloseStrip
             });

            var api = $s.data("overlay");
            api.load();
            
            $s.focus();
            


            
            var swipeStatus = function (event, phase, direction, distance)
            {
                if(phase == 'start' ) {
                    ox = getLeftOffset($s);   
                } else if( phase=="move" && (direction=="left" || direction=="right") )
                {
                    if (direction == "left") {
                        scrollImages(ox - distance, 0);
                        //$s.css('left', (ox - distance) + 'px');                    
                    } else if (direction == "right") {
                        scrollImages(ox + distance, 0);
                        //$s.css('left', (ox + distance) + 'px');                    
                    //methods.scrollImages((item_w * current_item) - distance, duration);
                    }
                    moved = true;
                }
                else if ( phase == "cancel")
                {
                    gotoActive();
                }
                else if ( phase =="end" )
                {
                    getActive();
                    if (direction == "right")
                        gotoPrev();
                    else if (direction == "left")            
                        gotoNext();
                }
            };            
            var swipeOptions=
            {
                triggerOnTouchEnd : true,    
                allowPageScroll:"none",
                threshold:200,
                onSeek : null
            }
            swipeOptions.swipeStatus = swipeStatus;
            $s.swipe( swipeOptions );
          //  $s.swipepage({allowPageScroll: 'none', onSeek : null});
            /*
            $s.bind('touchstart', function(e) {
                var touch = getTouches(e)[0];
                drag = true;
                moved = false;
                var p = $s.position();
                ox = p.left - touch.pageX;
                return false;                
            });
            $s.bind('touchend.strip', function(e) {
                var touch = getTouches(e)[0];
                if(drag) {
                    getActive();
                }
                drag = false;
                if(!moved) {
                    var w = $('body').width();
                    if(w / 2 < touch.pageX) {
                        gotoNext();
                    } else {
                        gotoPrev();
                    }
                }
            });
            $s.bind('touchmove.strip', function(e) {
                if(drag) {
                    var touch = getTouches(e)[0];
                    moved = true;
                    var x = touch.pageX;
                    $s.css('left', (p.left + x + ox) + 'px');
                }
            });            
            */
            var key_pressed = 0;
            
            setTimeout(function() {
                
            $('#crsa-mask').bind('click.strip', function() {
                closeStrip();
            });
                            
            $s.bind('mousedown', function(e) {
                drag = true;
                moved = false;
                $s.addClass('grabbed');
                ox = getLeftOffset($s) - e.pageX;
                return false;
            });
            $('body').bind('keyup.strip', function(e) {
                key_pressed = 0;
            });
                        
            $('body').bind('keydown.strip', function(e) {
              //  if(key_pressed == e.which) return false;
                console.log(e.which);
                switch(e.which) {
                    case 37:
                        gotoPrev();
                        break;
                    case 39:
                    case 32:
                    case 13:
                        gotoNext();
                        break;
                    default:
                        return true;
                }
                key_pressed = e.which;
                return false;
            });
            
            $s.bind('mouseup.strip', function(e) {
                if(drag) {
                    getActive();
                    $s.removeClass('grabbed');
                }
                drag = false;
                if(!moved) {
                    var w = $('body').width();
                    if(w / 2 < e.pageX) {
                        gotoNext();
                    } else {
                        gotoPrev();
                    }
                }
                return false;
            });
            $('body').bind('mouseup.strip', function(e) {
                if(drag) {
                    getActive();
                    $s.removeClass('grabbed');
                }
                drag = false;
                return false;
            });
            $('body').bind('mousemove.strip', function(e) {
                if(drag) {
                    moved = true;
                    var x = e.pageX;
                    var nx = x + ox;
                 //   console.log('nx ' + nx + ' x ' + x + ' ox ' + ox);
                    //$s.css('left', nx + 'px');
                    scrollImages(nx, 0);
                    if(skip_moves == 0) {
                        getActive();
                        skip_moves = 4;
                    }
                    skip_moves--;
                }
            });
            }, 500);
            
            $s.bind('gotoActive.strip', function() {
                gotoActive();
            });
                        
            
            if(jump) {
                gotoItem(jump, 0);
            } else {
                gotoItem(0, 0);
            }
            getActive();
        },
        showPhotoStrip : function($s, jump, data) {
            var b = '<div class="crsa-photo-strip">';
            if(!data) {
                var imgs = $s.find('> a');
                imgs.each(function(i,e) {
                    var $e = $(e);
                    var $i = $e.find('img');
                    b += '<div class="crsa-photo"><img src="' + $e.attr('href') + '" /></div>';
                });
            } else {
              $.each(data, function(ind, p) {
                  b += '<div class="crsa-photo"><img src="' + p.source + '" />';
                  if(p.name) {
                      b += '<div class="crsa-photo-desc"><div>' + p.name + '</div></div>';
                  }
                  b += '</div>';
              });            
            }
            b += '</div>';
            
            var $dest = $('body');
            $('#cms').after(b);
            //$dest.append(b);
            
            var $s = $dest.find('div.crsa-photo-strip');
            
            methods.resizeStripPhotos($s, data);
            
            main_el.bind('crsaAfterResize.strip', function() {
                methods.resizeStripPhotos($s, data);
               // gotoActive();
            });
            
            methods.wireStrip($s, jump);
        },
        resizeStripPhotos : function($s, data) {
            if(data) {
                var len = 0;
                var wh = methods.getWindowHeight();
                var availh = wh - 120;
                
                var h = $s.height();
                
                h = availh;
                
                var max_h = 0;
                var min_h = 99999999;
                var imgs = $s.find('> div.crsa-photo');
      
                var has_desc = false;          
                $.each(data, function(ind, p) {
                    var ph = parseInt(p.height);
                    if(max_h < ph) max_h = ph;
                    if(min_h > ph) min_h = ph;
                    if(p.name) {
                        has_desc = true;
                    }
                    
                });

                var scale = 1.0;
                if(h < min_h) min_h = h;
                
                var seth = min_h;
                
                if(seth > h) {
                    seth = h;
                } else {
                    seth = seth * 1;
                    if(seth > h) seth = h;
                }
                //seth = availh;
                seth = parseInt(seth);
                
                //if(h < max_h) scale = h*1.0 / max_h;
                 
                var last = null;              
                $.each(data, function(ind, p) {
                    var ph = parseInt(p.height);
                    var pw = parseInt(p.width);
                    
                    var scale = 1.0;
                    scale = seth*1.0 / ph;
                    
                    pw = parseInt(pw * scale);
                    ph = parseInt(ph * scale);
                    
                    len += pw + 10;
                    
                    var $c = $(imgs.get(ind));
                    var $img = $c.find('img');
                    $img.attr('width', pw).attr('height', ph).css('height','auto');
                    last = $c;
                });

                
                $s.css('height', seth + 'px').css('top', parseInt((wh - seth - 40)/2) + 'px').css('width', len + 'px');
                
                if(has_desc) $s.addClass('with_desc');
                
                $s.trigger('gotoActive.strip');
            }
        },
        resizeToolTab : function($c) {
            var resize = function() {
                if($c.css('position') != 'fixed') {
                    var o = main_el.offset();
                    var h = methods.getWindowHeight() - o.top - 20;
                    $c.css('top',o.top + 'px').css('height',h + 'px');
                }
            };
            resize();
            $(window).bind('resize', resize);
        },
        showComments : function() {
            var $c = $('#crsa-comments');
            if($c .length == 0) {
                $('#cms').before('<div id="crsa-comments"><div style="background:#fff;padding:10px;border-radius: 10px;"><div class="fb-comments" data-href="' + settings.nice_url + '" data-num-posts="10" data-aaacolorscheme="dark" data-width="480"></div></div><a href="#" class="crsa-close-comments"></a></div>');
                $c = $('#crsa-comments');
                
                methods.resizeToolTab($c);
                
                $c.find('a.crsa-close-comments').click(function() {
                    $c.fadeOut(500, function() { $c.hide(); });
                    $("#crsa-circle-comment").removeClass("selected");
                    return false;
                });
                FB.XFBML.parse(document.getElementById('crsa-comments'));
            }
            $c.show();
        },
        getFbAppId : function() {
            return settings.fb_app_id;
        },
        logout : function(red) {
            methods.waitStart();
            var url = '/logout';
            if(red) url += red;
            if(typeof FB != 'undefined') {
                FB.getLoginStatus(function(response) {
                    console.log(response.status);
                    if (response.status === 'connected') {        
                        FB.logout(function() {
                            window.location.href = url;  
                        });  
                        return;
                    } else {
                        window.location.href = url;
                        return;
                    }
                });
                return;
            }
            window.location.href = url;
        },   
         userRegistration : function(mode, func, popt) {
             if(typeof mode == 'undefined') mode = 'sel';
             if(typeof func == 'undefined') func = null;

             var opt = { ajax: true, plan: null, redirect: null };
             $.extend( opt, popt );
                       
             if(user_reg_timer != null) clearTimeout(user_reg_timer);
             
             var b = '<div id="crsa-ur">';
             
             var fbb = '';
             if(typeof FB != 'undefined') {
                fbb = '<div class="crsa-fb-login-w"><a href="#" class="crsa-fb-login">Login/Register with Facebook</a>or use a Pllop account:</div>';
             }
             
             switch(mode) {
                 case 'sel':
                 case 'sel_log':
                    b += '<h1>Hey, you are not logged in!</h1>' + fbb + '<p class="crsa-ur-warn">You need to <a href="#" class="crsa-login">login</a> or <a href="#" class="crsa-register">register</a> to keep your work.</p>';
                    break;
                 case 'reg':
                    b += '<h1>Create your Pllop space</h1>' + fbb + '<p class="crsa-ur-warn">You need to register to keep your work.</p>';
                    break;
                 case 'log':
                    b += '<h1>Login</h1>' + fbb + '<p class="crsa-ur-warn">You need to login to keep your work.</p>';
                    break;
             }             
             b += '<div id="crsa-login-div"><h2>Welcome back!</h2><form method="post" action="/js/crsa/empty.html" target="dummyframe"><div class="crsa-ur-email"><p class="error" style="display:none;"></p><label>E-mail:</label><span class="crsa-ph"></span><!--<input type="text" name="email" class="cms_input" />--></div><div class="crsa-ur-password"><p class="error" style="display:none;"></p><label>Password:</label><span class="crsa-ph"></span><!--<input type="password" name="password" class="cms_input" />--></div><input type="submit" value="Login!" /></form></div>';
             
             b += '<div id="crsa-register-div"><h2>Be a part of the Pllop family!</h2><form method="post" action="/js/crsa/empty.html"><div class="crsa-ur-email"><p class="error" style="display:none;"></p><label>E-mail:</label><input type="text" name="email" class="cms_input" /></div><div class="crsa-ur-password"><p class="error" style="display:none;"></p><label>Password:</label><input type="password" name="password" class="cms_input" /></div><div class="crsa-ur-username"><p class="error" style="display:none;"></p><label>Your Pllop url:</label>pllop.com/<span></span><input type="text" name="username" class="cms_input" /></div><div class="checkbox" style="display:none;"><input type="checkbox" class="cms_checkbox" name="news" /><label>Subscribe to Pllop News</label><small>Sent once or twice per month. Contains tutorials, tips, news and show cases.</small></div><input type="submit" value="Create my Pllop Space!" /></form></div>';
             
             b += '<a class="crsa-ur-close" href="#">I just want to play around. Ask me again later.</a><div class="crsa-ur-be-here" style="display:none;">I will be right here waiting for you...</div></div>';
             
             var $c = $('#crsa-ur');
             if($c.length == 0) {
                 $('#cms').append(b);
                 var $c = $('#crsa-ur');
             }
             
             $c.find('#crsa-login-div div.crsa-ur-email span').replaceWith($('#static_email'));
             $c.find('#crsa-login-div div.crsa-ur-password span').replaceWith($('#static_password'));
             
             $c.find('.crsa-ur-username input').bind('input', function(e) {
                 $c.find('.crsa-ur-username span').html($(e.target).val());
             });
             
             $c.overlay({
                    mask: {
                        color1: '#03abf1',
                        color: '#000000',
                        loadSpeed: 200,
                        opacity: 0.5,
                        maskId: 'crsa-mask'
                    },
                    closeOnClick: false,
                    closeOnEsc: false,
                    left: 'center',
                    top: '10%'
             });
             var api = $c.data("overlay");
             api.load();
             
                 
             //$c.animate({'top': '0px'}, 1000);
             $c.find('.crsa-fb-login').click(function() {
                methods.doFacebookLogin(function(r) {
                    var api = $c.data("overlay");
                    api.close();
                    if(func) func();
                });
                return false;
             });
             
             $c.find('.crsa-ur-close').click(function() {
    /*            var d = 0 - $c.innerHeight() + 45;
                $c.animate({'top': d + 'px'}, 1000);
                ur_hidden = true;
                $c.find('.crsa-ur-be-here').show();
                */
                var api = $c.data("overlay");
                api.close();
             });
             
             $c.mouseenter(function() {
                if(ur_hidden) {
                    $c.animate({'top': '0px'}, 1000);
                    ur_hidden = false;
                    $c.find('.crsa-ur-be-here').hide();
                }
             });
             
             $c.find('.crsa-login').click(function() {
                $('#crsa-register-div').hide();
                $('#crsa-login-div').show();
                return false;
             });
             $c.find('.crsa-register').click(function() {
                $('#crsa-register-div').show();
                $('#crsa-login-div').hide();
                return false;
             });
             
             switch(mode) {
                 case 'sel':
                    break;
                 case 'reg':
                    $('#crsa-register-div').show();
                    $('#crsa-login-div').hide();                 
                    break;
                 case 'log':
                 case 'sel_log':
                    $('#crsa-register-div').hide();
                    $('#crsa-login-div').show();                 
                    break;
             }                 
             
             $c.find('#crsa-register-div form').submit(function() {
                 var $cc = $('#crsa-register-div');
                 var email = $cc.find('.crsa-ur-email input').val();
                 var pass = $cc.find('.crsa-ur-password input').val();
                 var username = $cc.find('.crsa-ur-username input').val();
                 var news = $cc.find('.cms_checkbox:checked').val() !== 'undefined' ? "1" : "0";
                 
                 var d = {email: email, password: pass, username: username, news: news, plan: opt.plan};
                 methods.waitStart();
                $.ajax({
                      url: settings.url_base + settings.reg_user_url,
                      dataType: 'json',
                      type: 'post',
                      data: {user: JSON.stringify(d)},
                      beforeSend:function(request) { 
                          request.setRequestHeader('X-Update', 'dummy');
                      },           
                      success: function(ret){
                          $cc.find('.crsa-ur-email .error').html('').hide();
                          $cc.find('.crsa-ur-password .error').html('').hide();
                          $cc.find('.crsa-ur-username .error').html('').hide();
                          $cc.find('.crsa-ur-email').removeClass('has_error');
                          $cc.find('.crsa-ur-password').removeClass('has_error');
                          $cc.find('.crsa-ur-username').removeClass('has_error');
                          if(ret.ok) {
                            console.log('ok');
                            var api = $c.data("overlay");
                            api.close();
                            settings.temp_user = false;
                            user_id = ret.user_id;
                            user_email = ret.user_email;
                            main_el.trigger('crsaUserLoggedIn');
                            if(func) func();
                            if(opt.redirect) window.location = opt.redirect;
                          } else {
                              if(ret.email_msg) {
                                  $cc.find('.crsa-ur-email .error').html(ret.email_msg).show();
                                  $cc.find('.crsa-ur-email').addClass('has_error');
                              }
                              if(ret.password_msg) {
                                  $cc.find('.crsa-ur-password .error').html(ret.password_msg).show();
                                  $cc.find('.crsa-ur-password').addClass('has_error');
                              }
                              if(ret.username_msg) {
                                  $cc.find('.crsa-ur-username .error').html(ret.username_msg).show();
                                  $cc.find('.crsa-ur-username').addClass('has_error');
                              }
                              console.log('error');
                          }
                          methods.waitDone();
                      },
                        error: function(a,b,c) {
                            methods.waitDone();
                            alert(a.responseText);
                        }          

                });             
                 return false;
             });
             
             $c.find('#crsa-login-div form').submit(function() {
                 var $cc = $('#crsa-login-div');
                 var email = $cc.find('.crsa-ur-email input').val();
                 var pass = $cc.find('.crsa-ur-password input').val();
                 
                 var d = {email: email, password: pass};
                 methods.waitStart();
                $.ajax({
                      url: settings.url_base + settings.login_user_url + '0',
                      dataType: 'json',
                      type: 'post',
                      data: {user: JSON.stringify(d)},
                      beforeSend:function(request) { 
                          request.setRequestHeader('X-Update', 'dummy');
                      },           
                      success: function(ret){
                          $cc.find('.crsa-ur-email .error').html('').hide();
                          $cc.find('.crsa-ur-password .error').html('').hide();
                          $cc.find('.crsa-ur-email').removeClass('has_error');
                          $cc.find('.crsa-ur-password').removeClass('has_error');
                          if(ret.ok) {
                            console.log('ok');
                            var api = $c.data("overlay");
                            api.close();
                            settings.temp_user = false;
                            user_id = ret.user_id;
                            user_email = ret.user_email;
                            main_el.trigger('crsaUserLoggedIn');
                            if(func) func();
                            if(opt.redirect) window.location = opt.redirect;
                            
                          } else {
                              if(ret.email_msg) {
                                  $cc.find('.crsa-ur-email .error').html(ret.email_msg).show();
                                  $cc.find('.crsa-ur-email').addClass('has_error');
                              }
                              if(ret.password_msg) {
                                  $cc.find('.crsa-ur-password .error').html(ret.password_msg).show();
                                  $cc.find('.crsa-ur-password').addClass('has_error');
                              }
                          }
                          methods.waitDone();
                      },
                        error: function(a,b,c) {
                            methods.waitDone();
                            alert(a.responseText);
                        }          

                });             
                // return false;
             });
             
             
         },
         waitStart : function() {
             wait_c++;
             if(wait_c > 0) {
                 $("#crsa-wait").show();
             }
         },
         waitDone : function() {
             wait_c--;
             if(wait_c < 0) wait_c = 0;
             if(wait_c == 0) {
                $("#crsa-wait").hide();
             }
         },
         embedMedia : function(dest, m) {
            var dw = dest.width();
            var ew, eh, ep = 0;
            
            if(m.indexOf('TWTR.Widget') > 0) {
                dest.html( "Reload the page to update the embedded media.");
                return;
            }
            
            var p = /<iframe[^\>]*\swidth=\"([0-9]+)\"[^\>]*\sheight=\"([0-9]+)\"[^\>]*youtube\.com\/embed/i;
            var a = m.match(p);
            if(!a) {
                var p = /<iframe[^\>]*\swidth=\"([0-9]+)\"[^\>]*\sheight=\"([0-9]+)\"[^\>]*maps\.google\.com\/maps/i;
                var a = m.match(p);
            }
            if(!a) {
                var p = /<iframe[^\>]*\.vimeo\.com\/video[^\>]*\swidth=\"([0-9]+)\"[^\>]*\sheight=\"([0-9]+)\"/i;
                var a = m.match(p);
            }
            if(a) {
                ew = parseInt(a[1]);
                eh = parseInt(a[2]);
                ep = (ew*1.0)/(eh*1.0);
                
                var nw = dw;
                var nh = parseInt(nw/ep);
                m = m.replace('width="' + ew + '"', 'width="' + nw + '"');
                m = m.replace('height="' + eh + '"', 'height="' + nh + '"');
            }
            //console.log(m);
            dest.html(m);
         },
         setPageSize : function(w, h) {
             var $m = $('#msb_mask');
             $m.css('width', w).css('height', h);
             auto_size_mask = false;
             $(window).trigger('resize');
         },
         setPageContent : function($e, c) {
             $e.find('> div > div.crsa-inner').html(c);
         },
         setPageBckImage : function($e, url, w, h, opt) {
            var stretch = false;
            var mb = $e.find('div.msb_bcks');
            if(mb.length == 0) {
                $e.prepend('<div class="msb_bcks"><img class="msb_element_bck"/></div>');
                mb = $e.find('div.msb_bcks');
                stretch = true;
            }
            mb.find('> img').remove();
            var i = mb.find('> img');
            if(i.length == 0) {
                mb.append('<img class="msb_element_bck" />');
                i = mb.find('> img');
            }
            if(typeof w == 'undefined' || !w) {
                var img = new Image();
                img.onload = function() {
                    w = this.width;
                    h = this.height;
                    i.attr('large', url);
                    i.attr('src', url);
                    i.data('owidth',w).data('oheight',h);
                    i.attr('data-owidth',w).attr('data-oheight',h);      
                    methods.fsStretchImages($e, opt);                
                }
                img.src = url;
            } else {
                i.attr('large', url);
                i.attr('src', url);
                i.data('owidth',w).data('oheight',h);
                i.attr('data-owidth',w).attr('data-oheight',h);   
                methods.fsStretchImages($e, opt);    
            }
         },
         clearPageBckImage : function($e) {
             $e.find('div.msb_bcks img').remove();
         },
         initCrsaInline : function(func) {
             $.getScript(settings.url_base + '/cob/callSmarty/MsbElement/externalInitCrsaInline/script.js', function() {
                 func();
             });
         },
         assignId : function($e) {
            var id = $e.attr('id');
            if(!id) {
                id_count++;
                $e.attr('id','crsatmpid_' + id_count);
            }
         },
         defferImageLoad : function($i) {
             var def = $i.data('crsa-deffer');
             if(def) return;
             var src = $i.attr('src');
             var defsrc = $i.attr('deffered-src');
             if(defsrc) {
                 src = defsrc;
                 $i.removeAttr('deffered-src');
             }
             $i.attr('src', pix_img).data('crsa-deffer', true).data('crsa-deffer-src', src);
         },
         loadDefferedImage : function($i) {
             var def = $i.data('crsa-deffer');
             if(def) {
                 var src = $i.data('crsa-deffer-src');
                 $i.attr('src', src).data('crsa-deffer', false);
             }                 
       /*      var mb = $i.parent();
             if(!mb.is(':visible')) {
                 mb.show();
             }*/
             methods.assignId($i);
             var id = $i.attr('id');
             
             var idx = -1;
             $.each(diq, function(i,$e) {
                 var mid = $e.attr('id');
                 if(mid == id) {
                     idx = i;
                     return false;
                 }
             });
             
             if(idx!=-1) diq.splice(idx, 1)
             diq.push($i);
             
             if(diq.length > 6) {
                 methods.releaseImage(diq.shift());
             }
         },
         releaseImage : function($i) {
             methods.defferImageLoad($i);
           //  $i.parent().hide();
         },
         manageImages : function() {
             var images = main_el.find('div.msb_bcks > img');
             images.each(function(i,e) {
                 methods.defferImageLoad($(e));
             });
             main_el.bind('crsaPageShown', function(event, data, forward) {
                // console.log(forward);
                 if(typeof forward == 'undefined' || forward === null) forward = true;
                 var $p = data;
                 var pimgs = $p.find('div.msb_bcks > img');
                 pimgs.each(function(i,e) {
                     methods.loadDefferedImage($(e));
                 });
                 var nextp = forward ? $p.nextAll("*:lt(3)") : $p.prevAll("*:lt(3)");
                 var pimgs = nextp.find('div.msb_bcks > img');
                 pimgs.each(function(i,e) {
                     methods.loadDefferedImage($(e));
                 });
             });
         }
        
    };

    var getImageSize = function(imgel) {
        var t = jQuery(imgel);

        var imagewidth = 0;
        var imageheight = 0;
        
        try {
            imagewidth = parseInt(t.attr('data-owidth'));
            imageheight = parseInt(t.attr('data-oheight'));
        } 
        catch(err) {
        }
        
        if(imagewidth == 0) {
            imagewidth = t.attr('width');
        }
        if(imageheight == 0) {
            imageheight = t.attr('height');
        }
        try {
            if(imagewidth == 0) {
                imagewidth = parseInt(imgel.outerHTML.match(/width=([0-9]+)/i)[1]);
            }
            if(imageheight == 0) {
                imageheight = parseInt(imgel.outerHTML.match(/height=([0-9]+)/i)[1]);
            }    
        }
        catch(err) {
        }
        return {w: imagewidth, h: imageheight};
    };
         
    $.fn.crsaruntime = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsa' );
    }    

    };

})( jQuery );